unix:DEFINES    = QT_DLL
win32:LIBS      = hdfeosdb.lib qt-mt.lib
INCLUDEPATH     = -I$(HDFEOS4)/include \
                  -I$(HDF4)/include \
                  -I$(GDAL)/include \
		  -I$(SHAPE)/include \
		  -I$(PROJ)/include \
unix:LIBS       = -L$(HDFEOS4)/lib/linux \
                  -L$(HDF4)/lib \
                  -L$(GDAL)/lib \
                  -L$(PROJ)/lib \
                  -lhdfeos -lmfhdf -lm -lz -ldf -lproj -lgdal
TEMPLATE    = app
CONFIG      = qt warn_on debug
HEADERS     =	src/image.h \
	src/histogramuser.h \
	src/histogramset.h \
	src/imagedlg.h \
	src/histogramdlg.h \
	src/glacierline.h \
	src/glacierconfigdlg.h \
	src/histogramdatasource.h \
	src/inmemformat.h \
	src/histogram.h \
	src/aboutdlg.h \
	src/glimsproject.h \
	src/l7a_geotiff.h \
	src/hdfeosfrmt.h \
	src/l7a_nlaps.h \
	src/glimsdataset.h \
	src/linedef.h \
	src/glimsgiddata.h \
	src/linedefdlg.h \
	src/glimsglobals.h \
	src/linedefset.h \
	src/glimslinedata.h \
	src/lineselectordlg.h \
	src/glacieriddef.h \
	src/imageformat.h \
	src/maintoolbar.h \
	src/imageinf.h \
	src/nlapsfrmt.h \
	src/odldefs.h \
	src/odlelement.h \
	src/glacieriddlg.h \
	src/odlparser.h \
	src/odltree.h \
	src/gdalfrmt.h \
	src/plugin.h \
	src/extaction.h \
	src/pluginset.h \
	src/dbfheader.h \
	src/projectdlg.h \
	src/selectionset.h \
	src/session.h \
	src/configdlg.h \
	src/sessiondlg.h \
	src/shape.h \
	src/simplelinedata.h \
	src/simplepointdata.h \
	src/bandchooserdlg.h \
	src/vectordata.h \
	src/attr.h \
	src/vectoreditor.h \
	src/imagestate.h \
	src/vectorlayer.h \
	src/imageinfdlg.h \
	src/vectorlayerset.h \
	src/l7a_fast.h \
	src/view.h \
	src/viewstate.h \
	src/viewpopupaction.h \
	src/viewset.h \
	src/zoomattr.h \
	src/windows_defs.h \
	src/xmlserializeable.h

SOURCES   =	src/viewset.cpp \
	src/aboutdlg.cpp \
	src/xmlserializeable.cpp \
	src/imageinfdlg.cpp \
	src/imagestate.cpp \
	src/bandchooserdlg.cpp \
	src/vectorlayer.cpp \
	src/configdlg.cpp \
	src/vectoreditor.cpp \
	src/vectorlayerset.cpp \
	src/view.cpp \
	src/gdalfrmt.cpp \
	src/vectordata.cpp \
	src/glacierconfigdlg.cpp \
	src/sessiondlg.cpp \
	src/pluginset.cpp \
	src/glacieriddlg.cpp \
	src/projectdlg.cpp \
	src/imageformat.cpp \
	src/glimsdataset.cpp \
	src/nlapsfrmt.cpp \
	src/selectionset.cpp \
	src/glimsgiddata.cpp \
	src/imageinf.cpp \
	src/glimsglobals.cpp \
	src/odlparser.cpp \
	src/glimslinedata.cpp \
	src/maintoolbar.cpp \
	src/glimsproject.cpp \
	src/linedefdlg.cpp \
	src/hdfeosfrmt.cpp \
	src/linedefset.cpp \
	src/line.cpp \
	src/l7a_nlaps.cpp \
	src/histogramdlg.cpp \
	src/l7a_geotiff.cpp \
	src/inmemformat.cpp \
	src/histogramuser.cpp \
	src/l7a_fast.cpp \
	src/image.cpp \
	src/imagedlg.cpp \
	src/viewpopupaction.cpp \
	src/lineselectordlg.cpp \
	src/plugin.cpp


INTERFACES =
