#include "statusdlg.h"


StatusDlg::StatusDlg( std::string msg ) :
    QWidget( NULL, "", true ),
    mMsg( msg )
{
    setMinimumSize( 250, 125 );
    setMaximumSize( 250, 125 );
    buildDialog();
}

void StatusDlg::buildDialog( )
{
    QVBoxLayout *vbl = new QVBoxLayout( this );
    vbl->setAutoAdd( true );
    vbl->setMargin( 15 );

    mLblMsg = new QLabel( mMsg.c_str(), this );
    mStatBar = new QProgressBar( this );
    mStatBar->setTotalSteps( 100 );
}

void StatusDlg::setVal( int ival )
{
    if( ival < 0 )
        ival = 0;
    if( ival >= 100 )
        ival = 100;

    mStatBar->setProgress( ival );
    qApp->processEvents();

}

void StatusDlg::setMsg( std::string msg )
{
    mMsg = msg;
    mLblMsg->setText( mMsg.c_str() );
    qApp->processEvents();
}
