#include "windows_defs.h"
#include "ThreasholdDlg.h"

extern "C" {

GV_EXPORT const char* getName( )
{
    return "Threshold Outline";
}

GV_EXPORT const char* getDesc( )
{
    const char *desc;

    desc =
    "This is a first attempt at an automatic glacier outline "
    "method.  To use this just adjust the \"Lower\" slider "
    "to the min DN value for snow/ice and adjust the \"Upper\" "
    "slider for the max DN value for snow/ice.  Then click "
    "\"Proceed\".  The result should be reasonable outlines of "
    "glaciers that can be then manually cleaned.";

    return desc;
}

GV_EXPORT void activate( GLIMSProject *proj )
{
    Threashold *tdlg = new Threashold( proj );
    tdlg->exec();
    delete tdlg;
}

}

