#include "aboutdlg.h"

const std::string AboutDlg::GV_VERSION = "1.0";
const std::string AboutDlg::GV_CREDITS = "\n\nMaintained and developed by Deborah Lee Soltesz. \nSpreadsheet Output by Erica Liszewski. \nImage Polygon Calculator by Erica Liszewski and Deborah Lee Soltesz.  \nOriginally created by Dan Mingus.\n\n";
const std::string AboutDlg::GV_DATE    = "2006-08-06 (beta release)";
const std::string AboutDlg::GV_WEBSITE = "http://www.glims.org/glimsview";

AboutDlg::AboutDlg( ) :
QDialog( NULL, "", true ) {
  this->setCaption( "About GLIMSView" );
  buildDlg();
}

void AboutDlg::buildDlg( ) {

  std::string title,
  credits,
  date,
  website,
  buildDate;

  title   = "GLIMSView v";
  title   += GV_VERSION;
  credits = "Created by: ";
  credits += GV_CREDITS;
  date    = "Release Date: ";
  date    += GV_DATE;
  website = "Website: ";
  website += GV_WEBSITE ;

  QVBoxLayout *vbl = new QVBoxLayout( this );
  vbl->setAutoAdd( true );
  vbl->setMargin( 30 );

  QVBox *txtbox = new QVBox( this );
  txtbox->setMargin( 15 );
  new QLabel( title.c_str(),   txtbox );
  new QLabel( date.c_str(),    txtbox );
  new QLabel( credits.c_str(), txtbox );
  new QLabel( website.c_str(), txtbox );

  QVBox *butbox = new QVBox( this );
  butbox->setMargin( 15 );
  QPushButton *pb = new QPushButton( "Close", butbox );
  pb->setMaximumWidth( 100 );
  connect( pb, SIGNAL( clicked() ), this, SLOT( close() ) );
}


