#ifndef __ABOUTDLG_H
#define __ABOUTDLG_H

#include <qdialog.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qvbox.h>

#include <string>

/**
 * Dialog box that provides basic "About GLIMSView" information.
 *
 * @author Dan Mingus
 * @history 2004-12-06 Deborah Lee Soltesz - tweaked information for latest release.
 *
 */
class AboutDlg : public QDialog {
protected:
/**
 * Loads up the dialog box with the "About GLIMSView" information.
 * Called by the constructor.
 */
  void buildDlg( );

public:

  static const std::string GV_VERSION;
  static const std::string GV_CREDITS;
  static const std::string GV_DATE;
  static const std::string GV_WEBSITE;

/**
 * Constructor calls parent class, sets the caption, then calls the buildDlg to load up
 * the About dialog with the relevant information.
 */
  AboutDlg( );
};

#endif



