#ifndef __ATTR_H
#define __ATTR_H

#include <string>
#include "xmlserializeable.h"

/**
 * Attr is an generic attribute holding an id and a value.  This
 * provides easy XML file io for attribute type of static data.
 *
 */
class Attr : public XMLSerializeable {
public:
  std::string     id;
  std::string     value;

  virtual bool fromXML( QDomElement &elem ) {
    QDomElement base;
    QDomNode node;
    /*
    if( std::string( "Attribute" ) != elem.tagName() )
        return false;
    */

    id = readTextTag( elem, "ID" );
    value = readTextTag( elem, "Value" );
    return true;
  }

  virtual bool toXML( QDomDocument &doc,
                      QDomElement &elem,
                      std::string id ) {
    QDomElement base = doc.createElement( "Attribute" );
    if ( id != "" )
      base.setAttribute( "id", (char*)id.c_str() );
    elem.appendChild( base );

    writeTextTag( doc, base, "ID", id );
    writeTextTag( doc, base, "Value", id );
    return true;
  }
};

#endif


