#ifndef __GDALFRMT_H
#define __GDALFRMT_H


#include <gdal.h>
#include <gdal_priv.h>
#include <ogr_spatialref.h>

#include "imageformat.h"

/**
 * ImageFormat implementation providing an interface to
 * the GDAL library.
 *
 * Information about the GDAL library can be found at
 * http://www.remotesensing.org/gdal/.
 *
 *
 * @history 2006-01-09 dls -
 *   Altered open function to pull fill in more metadata from image
 *   in ImageInf structure
 */

class GDALFrmt : public ImageFormat {
protected:
  GDALDataset *mDataSet;       // GDAL DATASET

public:
  GDALFrmt( );
  virtual ~GDALFrmt( );

  virtual void* getBand( int iband,
                         int x1,
                         int y1,
                         int w1,
                         int h1,
                         int w2,
                         int h2,
                         ScaleType st = SCALE_NN ) const;

  virtual void getLL( int iBand, double &i, double &j );
  virtual void getXY( int iBand, double &i, double &j );
  virtual bool open( std:: string fname );
};

#endif




