#include "glimsdataset.h"
#include <qmessagebox.h>

GLIMSDataset::GLIMSDataset( Image *img ) :
mImg( img ) {
  mSession.mRC_ID = 0 ;
  mLineData.setImage( img );
  mGIDData.setImage( img );
  mImgInf = img->getImageInf();
}

bool GLIMSDataset::toXML( QDomDocument &doc,
                          QDomElement &elem,
                          std::string ) {
  mImg->setCornerPnts( mImgInf );
  double x = mImg->width() / 2;
  double y = mImg->height() / 2;
  mImg->getLL( x, y );
  mImgInf.mCenterLat = y;
  mImgInf.mCenterLon = x;

  if ( !mImgInf.toXML( doc, elem ) )
    return false;

  if ( !mSession.toXML( doc, elem ) )
    return false;

  if ( !mGIDData.toXML( doc, elem ) )
    return false;

  if ( !mLineData.toXML( doc, elem ) )
    return false;

  return true;
}

bool GLIMSDataset::fromXML( QDomElement &elem ) {
  QDomNode node;
  QDomElement e;
  if ( !mImgInf.fromXML( elem ) )
    return false;

  node = elem.nextSibling();
  if ( !node.isElement() )
    return false;
  e = node.toElement();
  if ( !mSession.fromXML( e ) )
    return false;

  node = node.nextSibling();
  if ( !node.isElement() )
    return false;
  e = node.toElement();
  if ( !mGIDData.fromXML( e ) )
    return false;

  node = node.nextSibling();
  if ( !node.isElement() )
    return false;
  e = node.toElement();
  if ( !mLineData.fromXML( e ) )
    return false;
  return true;
}

// make updates to project as needed based on project version
void GLIMSDataset::updateVersion (QDate * currentVersion) {
  mGIDData.updateVersion (currentVersion) ;
}


