#include "histogram.h"

/**
 * A group of Histograms that are generated from a
 * HistogramDataSource.  This provides routines to
 * add, modify, and retrieve the Histogram information.
 *
 */
class HistogramSet {
protected:
  Histogram           mHistSet[3];
  bool                mIsColor;

public:
  HistogramSet( ) {

  }

  /*
  ~HistogramSet( )
  {
      if( mHistSet[0] )
          delete mHistSet[0];
      if( mHistSet[1] )
          delete mHistSet[1];
      if( mHistSet[2] )
          delete mHistSet[2];
  }
  */

  template<class DType>
  void setData( DType *rdata,
                int rlen,
                DType *gdata=NULL,
                int glen=0,
                DType *bdata=NULL,
                int blen=0 ) {
    if ( gdata == NULL || bdata == NULL )
      mIsColor = false;
    else
      mIsColor = true;

    mHistSet[0].calcHist( rdata, rlen );

    if ( mIsColor ) {
      if ( gdata )
        mHistSet[1].calcHist( gdata, glen );

      if ( bdata )
        mHistSet[2].calcHist( bdata, blen );
    }
  }

  bool isColor( ) {
    return mIsColor;
  }

  Histogram* operator[]( int iHist ) {
    // iHist = abs( iHist % 3 );
    return &mHistSet[ iHist ];
  }

  Histogram* getHist( int iHist ) {
    iHist = abs( iHist % 3 );
    return &mHistSet[ iHist ];
  }
};


