#include "imagedlg.h"
#include "image.h"

ImageDlg::ImageDlg( std::string &img, int &type ) :
QDialog( NULL, NULL, true ),
mImg( img ),
mType( type ) {
  setCaption( "Image Selection" );

  for ( int imffn=0; imffn < Image::NUM_MFF; imffn++ )
    mTypeSet.push_back( Image::MFF_NAMES[imffn] );

  buildDialog();
}


void ImageDlg::buildDialog( ) {
  QHBox   *hbox = NULL;
  QGrid   *grid = NULL;
  QPushButton *but = NULL;

  QVBoxLayout *vbox = new QVBoxLayout( this );
  vbox->setAutoAdd( true );
  vbox->setMargin( 10 );

  grid = new QGrid( 2, this );
  grid->setSpacing( 7 );
  grid->setMargin( 5 );

  // grid = new QGrid( 2, this );
  new QLabel( "Image: ", grid );
  hbox = new QHBox( grid );
  hbox->setSpacing( 5 );
  mTxtImg = new QLineEdit( hbox );
  mTxtImg->setMinimumWidth( 225 );
  but = new QPushButton( "Browse", hbox );
  connect( but, SIGNAL( clicked() ), this, SLOT( setImg() ) );

  mChkMulti = new QCheckBox( "Multi File", grid );
  connect( mChkMulti, SIGNAL( toggled( bool ) ), this, SLOT( chkToggle( bool ) ) );
  mCmbType = new QComboBox( grid );
  mCmbType->setEnabled( false );
  mCmbType->setMaximumWidth( 200 );
  loadTypes();

  // grid = new QGrid( 2, this );
  hbox = new QHBox( this );
  hbox->setMargin( 5 );
  but = new QPushButton( "Open", hbox );
  but->setMaximumWidth( 85 );
  connect( but, SIGNAL( clicked() ), this, SLOT( create() ) );
  but = new QPushButton( "Cancel", hbox );
  but->setMaximumWidth( 85 );
  connect( but, SIGNAL( clicked() ), this, SLOT( reject() ) );
}

void ImageDlg::setImg( ) {
  QString img = QFileDialog::getOpenFileName( QString::null, QString::null, this );
  if ( img.isNull() )
    return;
  mTxtImg->setText( (const char*)img );
}

void ImageDlg::create( ) {
  mImg = (const char*)mTxtImg->text();
  if ( mChkMulti->isChecked() )
    mType = mCmbType->currentItem();
  else
    mType = -1;

  accept();
}

void ImageDlg::chkToggle( bool toggle ) {
  mCmbType->setEnabled( toggle );
}

void ImageDlg::loadTypes( ) {
  for ( int i=0; i < (int)mTypeSet.size(); i++ )
    mCmbType->insertItem( mTypeSet[i].c_str() );
}


