#include "imageformat.h"
#include <iostream>

ImageFormat::ImageFormat( ) {
  // mParms = new (char*)[15];
}

ImageFormat::~ImageFormat( ) {
  // delete [] mParms;
}

/*
void ImageFormat::getImageInf( GlimsDataset::ImageInf &imginf )
{

}
*/

std::vector<ImageFormat::BandInf>& ImageFormat::getBandInfSet( ) {
  return mBandSet;
}

const ImageFormat::BandInf& ImageFormat::getBandInf( int iband ) {
  return mBandSet[iband];
}

std::string ImageFormat::getName( ) const {
  return mFName;
}

std::string ImageFormat::dtypeToString( ImageFormat::DataType dt ) {
  std::string dtype;

  switch ( dt ) {
    case ImageFormat::NOT_DEFINED:
      dtype = "UNSUPPORTED";
      break;

    case ImageFormat::INT8:
      dtype = "INT8";
      break;

    case ImageFormat::UINT8:
      dtype = "UINT8";
      break;

    case ImageFormat::INT16:
      dtype = "INT16";
      break;

    case ImageFormat::UINT16:
      dtype = "UINT16";
      break;

    case ImageFormat::INT32:
      dtype = "INT32";
      break;

    case ImageFormat::UINT32:
      dtype = "UINT32";
      break;

    case ImageFormat::INT64:
      dtype = "INT64";
      break;

    case ImageFormat::UINT64:
      dtype = "UINT64";
      break;

    case ImageFormat::FLOAT16:
      dtype = "FLOAT16";
      break;

    case ImageFormat::FLOAT32:
      dtype = "FLOAT32";
      break;

    case ImageFormat::FLOAT64:
      dtype = "FLOAT64";
      break;

    default:
      dtype = "UNDEF";
      break;
  }

  return dtype;
}

int ImageFormat::dtypeSize( ImageFormat::DataType dt ) {
  int sz_dtype;

  switch ( dt ) {
    case ImageFormat::NOT_DEFINED:
      sz_dtype = 0;
      break;

    case ImageFormat::INT8:
      sz_dtype = 1;
      break;

    case ImageFormat::UINT8:
      sz_dtype = 1;
      break;

    case ImageFormat::INT16:
      sz_dtype = 2;
      break;

    case ImageFormat::UINT16:
      sz_dtype = 2;
      break;

    case ImageFormat::INT32:
      sz_dtype = 4;
      break;

    case ImageFormat::UINT32:
      sz_dtype = 4;
      break;

    case ImageFormat::INT64:
      sz_dtype = 8;
      break;

    case ImageFormat::UINT64:
      sz_dtype = 8;
      break;

    case ImageFormat::FLOAT16:
      sz_dtype = 2;
      break;

    case ImageFormat::FLOAT32:
      sz_dtype = 4;
      break;

    case ImageFormat::FLOAT64:
      sz_dtype = 8;
      break;

    default:
      sz_dtype = 0;
      break;
  }

  return sz_dtype;
}

bool ImageFormat::isFloat( ImageFormat::DataType dt ) {
  switch ( dt ) {
    case ImageFormat::NOT_DEFINED:
      return false;
      break;

    case ImageFormat::INT8:
      return false;
      break;

    case ImageFormat::UINT8:
      return false;
      break;

    case ImageFormat::INT16:
      return false;
      break;

    case ImageFormat::UINT16:
      return false;
      break;

    case ImageFormat::INT32:
      return false;
      break;

    case ImageFormat::UINT32:
      return false;
      break;

    case ImageFormat::INT64:
      return false;
      break;

    case ImageFormat::UINT64:
      return false;
      break;

    default:
      return true;
      break;
  }

  return true;
}

char* ImageFormat::scaleData( char **orig,
                              int ow,
                              int oh,
                              int nw,
                              int nh,
                              DataType dt,
                              ScaleType st,
                              bool del ) const {
  return scaleData( orig, 0, 0, ow, oh, ow, oh, nw, nh, dt, st, del );
}

char* ImageFormat::scaleData( char **orig,
                              int ox,
                              int oy,
                              int ow,
                              int oh,
                              int fw,
                              int fh,
                              int nw,
                              int nh,
                              DataType dt,
                              ScaleType st,
                              bool del ) const {
  char *newData = NULL ;
  bool gotNew = true;

  //\todo handle SCALE_BC in switch statements to get rid of compile warning
  switch ( dt ) {
    case INT8:
      switch ( st ) {
        case SCALE_NN:
          newData = (char*)scl_nearestneighbor( (char*)*orig, ox, oy, ow, oh, fw, fh, nw, nh );
          break;

        case SCALE_BI:
          newData = (char*)scl_bilinear( (char*)*orig, ox, oy, ow, oh, fw, fh, nw, nh );
          break;
        default: ;
      }
      // newData = (char*)scaleDT( *orig, ox, oy, ow, oh, fw, fh, nw, nh, st );
      break;

    case INT16:
      switch ( st ) {
        case SCALE_NN:
          newData = (char*)scl_nearestneighbor( (short*)*orig, ox, oy, ow, oh, fw, fh, nw, nh );
          break;

        case SCALE_BI:
          newData = (char*)scl_bilinear( (short*)*orig, ox, oy, ow, oh, fw, fh, nw, nh );
          break;
        default: ;
      }
      break;

    case UINT8:
      switch ( st ) {
        case SCALE_NN:
          newData = (char*)scl_nearestneighbor( (unsigned char*)*orig, ox, oy, ow, oh, fw, fh, nw, nh );
          break;

        case SCALE_BI:
          newData = (char*)scl_bilinear( (unsigned char*)*orig, ox, oy, ow, oh, fw, fh, nw, nh );
          break;
        default: ;
      }
      break;

    case UINT16:
      switch ( st ) {
        case SCALE_NN:
          newData = (char*)scl_nearestneighbor( (unsigned short*)*orig, ox, oy, ow, oh, fw, fh, nw, nh );
          break;

        case SCALE_BI:
          newData = (char*)scl_bilinear( (unsigned short*)*orig, ox, oy, ow, oh, fw, fh, nw, nh );
          break;
        default: ;
      }
      // newData = (char*)scaleDT( (unsigned short*)*orig, ox, oy, ow, oh, fw, fh, nw, nh, st );
      break;

    case FLOAT32:
      switch ( st ) {
        case SCALE_NN:
          newData = (char*)scl_nearestneighbor( (float*)*orig, ox, oy, ow, oh, fw, fh, nw, nh );
          break;

        case SCALE_BI:
          newData = (char*)scl_bilinear( (float*)*orig, ox, oy, ow, oh, fw, fh, nw, nh );
          break;
        default: ;
      }
      // newData = (char*)scaleDT( (float*)*orig, ox, oy, ow, oh, fw, fh, nw, nh, st );
      break;

    case FLOAT64:
      switch ( st ) {
        case SCALE_NN:
          newData = (char*)scl_nearestneighbor( (double*)*orig, ox, oy, ow, oh, fw, fh, nw, nh );
          break;

        case SCALE_BI:
          newData = (char*)scl_bilinear( (double*)*orig, ox, oy, ow, oh, fw, fh, nw, nh );
          break;
        default: ;
      }
      // newData = (char*)scaleDT( (double*)*orig, ox, oy, ow, oh, fw, fh, nw, nh, st );
      break;

    default:
      newData = *orig;
      gotNew = false;
      break;
  }

  if ( gotNew && del )
    delete [] *orig;

  *orig = newData;
  return newData;
}

template<class DType> DType*
ImageFormat::scaleDT( DType* orig,
                      int ox,
                      int oy,
                      int ow,
                      int oh,
                      int fw,
                      int fh,
                      int nw,
                      int nh,
                      ScaleType st ) const {
  char *newData = NULL;
  switch ( st ) {
    case SCALE_NN:
      //newData = (char*)scl_nearestneighbor( orig, ox, oy, ow, oh, fw, fh, nw, nh );
      break;

    case SCALE_BI:
      //newData = (char*)scl_bilinear( (char*)orig, ox, oy, ow, oh, fw, fh, nw, nh );
      break;

    case SCALE_BC:
      // newData = scl_bicubic( orig, ow, oh, nw, nh, 0 );
      break;

    default:
      return orig;
  }

  return(DType*)newData;
}

template<typename DType> DType*
ImageFormat::scl_nearestneighbor( DType* orig,
                                  int ox,
                                  int oy,
                                  int ow,
                                  int , // oh,
                                  int fw,
                                  int fh,   // fh,
                                  int nw,
                                  int nh ) const {
  if ( nw == 0 ) return NULL;

  DType* newData = new DType[ nw*nh ];
  double x1 = 0.0, y1= 0.0, x2=0.0, y2=0.0;
  int    ind1, ind2, yind1, yind2;
  double scl;

  scl = (double)ow / (double)nw;

  for ( y2=0.0; (int)y2 < nh; y2++ ) {
    y1 = y2 * scl + oy;
    y1 = ((y1 > 0.0 ) ? (int)(y1+0.5) : (int)(y1-0.5));
    yind1 = (int)(y1 * fw);
    yind2 = (int)(y2 * nw);

    for ( x2=0.0; (int)x2 < nw; x2++ ) {
      x1 = x2 * scl + ox;
      x1 = ((x1 > 0.0 ) ? (int)(x1+0.5) : (int)(x1-0.5));

      // COULD POSSIBLY BE TAKEN OUT
      /*
      if( x1 < 0.0 ) x1 = 0.0;
      if( x1 >= fw ) x1 = (double)(fw-1);
      if( y1 < 0.0 ) y1 = 0.0; */
      if ( y1 >= fh ) y1 = (double)(fh-1);

      ind1 = (int)(yind1 + x1);
      ind2 = (int)(yind2 + x2);
      newData[ind2] = orig[ind1];
    }
  }

  return newData;
}

template<class DType> DType*
ImageFormat::scl_bilinear( DType* orig,
                           int ox,
                           int oy,
                           int ow,
                           int oh,
                           int fw,
                           int , // fh,
                           int nw,
                           int nh ) const {
  if ( nw == 0 || nh == 0 ) return NULL;

  DType   dn1, dn2, dn3, dn4;
  double  ix, iy, tx, ty;
  double  scl, mx, my;
  int     fox, foy, cox, coy;
  int     oicx, oicy, oifx, oify;
  DType*  newData = new DType[ nw*nh ];

  scl = (double)ow / (double)nw;

  for ( int y=0; y < nh; y++ ) {
    iy = y * scl;
    for ( int x=0; x < nw; x++ ) {
      ix = x * scl;
      fox = (int)ix;
      foy = (int)iy;
      cox = fox + 1;
      coy = foy + 1;


      if ( coy >= oh )
        coy = (int)(oh-1);

      oify = (oy+foy) * fw;
      oicy = (oy+coy) * fw;
      oifx = ox+fox;
      oicx = ox+cox;

      dn1 = orig[ oify + oifx ];
      dn2 = orig[ oify + oicx ];
      dn3 = orig[ oicy + oifx ];
      dn4 = orig[ oicy + oicx ];

      tx = ix - (int)ix;
      ty = iy - (int)iy;

      mx = 1.0 - tx;
      my = 1.0 - ty;
      newData[ y*nw+x ] = (DType)( mx*my*dn1 + tx*my*dn2 + mx*ty*dn3 + tx*ty*dn4 );
    }
  }

  return newData;
}

unsigned char* ImageFormat::scl_bicubic( unsigned char*,
                                         int,
                                         int,
                                         int,
                                         int,
                                         int ) const {
  return NULL;
}

void ImageFormat::setCornerPnts( int iband, ImageInf &inf ) {
  Node p1, p2, p3, p4;

  p1.x = 0.0;
  p1.y = 0.0;
  p1.z = 0.0;
  p2.x = mBandSet[iband].width;
  p2.y = 0.0;
  p2.z = 0.0;
  p3.x = mBandSet[iband].width;
  p3.y = mBandSet[iband].height;
  p3.z = 0.0;
  p4.x = 0.0;
  p4.y = mBandSet[iband].height;
  p4.z = 0.0;

  getLL( iband, p1.x, p1.y );
  getLL( iband, p2.x, p2.y );
  getLL( iband, p3.x, p3.y );
  getLL( iband, p4.x, p4.y );

  inf.mP1 = p1;
  inf.mP2 = p2;
  inf.mP3 = p3;
  inf.mP4 = p4;

}

void ImageFormat::xyToMeter( int iband, double &x, double &y ) {
  double angle;
  double r;
  BandInf &binf = mBandSet[iband];

  if ( iband < 0 || iband >= (int)mBandSet.size() ) return;

  if ( binf.proj == "" )
    return;

  if ( binf.rot != 0.0 ) {
    r = sqrt( x*x + y*y );
    if ( x < 0 )
      angle = acos( (x*-1.0) / r );
    else
      angle = acos( x / r );

    // ADJUST FOR NON IMAGE QUADRANT
    if ( x < 0 && y > 0 )
      angle = M_PI - angle;
    else if ( x < 0 && y < 0 )
      angle += M_PI;
    else if ( x > 0 && y < 0 )
      angle = M_PI + (M_PI-angle);

    // APPLY BAND ROTATION
    angle += (binf.rot * DEG_TO_RAD);

    x = r*( cos( angle ) );
    y = r*( sin( angle ) );
  }

  x = binf.ulx + ( x * binf.res );
  y = binf.uly - ( y * binf.res );
}

void ImageFormat::meterToLL( int iband, double &x, double &y ) {
  projXY xy;
  projPJ pj;

  if ( iband < 0 || iband >= (int)mBandSet.size() ) return;

  if ( !(pj = createProj( iband )) )
    return;

  xy.u = x;
  xy.v = y;
  xy = pj_inv( xy, pj );
  x = xy.u * RAD_TO_DEG;
  y = xy.v * RAD_TO_DEG;
  pj_free( pj );
}

void ImageFormat::llToMeter( int iband, double &lon, double &lat ) {
  projXY xy;
  projPJ pj;

  if ( iband < 0 || iband >= (int)mBandSet.size() ) return;

  if ( !(pj = createProj( iband )) )
    return;

  xy.u = lon * DEG_TO_RAD;
  xy.v = lat * DEG_TO_RAD;
  xy = pj_fwd( xy, pj );
  lon = xy.u;
  lat = xy.v;
  pj_free( pj );
}

void ImageFormat::llToXY( int iband, double &lon, double &lat ) {
  double x, y;
  double r;
  double angle;

  if ( iband < 0 || iband >= (int)mBandSet.size() ) return;
  llToMeter( iband, lon, lat );
  double ulx = mBandSet[iband].ulx;
  double uly = mBandSet[iband].uly;

  x = (lon - ulx) / mBandSet[iband].res;
  y = uly - lat;

  /*
  if( uly > 0 )
      y = uly - lat;
  else
      y = lat - uly;
  */

  y /= mBandSet[iband].res;

  // APPLY A ROTATION AROUND [0,0]
  r = sqrt( x*x + y*y );
  if ( x < 0 )
    angle = acos( (x*-1.0) / r );
  else
    angle = acos( x / r );

  if ( x < 0 && y > 0 )
    angle = M_PI - angle;
  else if ( x < 0 && y < 0 )
    angle += M_PI;
  else if ( x > 0 && y < 0 )
    angle = M_PI + (M_PI-angle);

  angle -= (mBandSet[iband].rot * DEG_TO_RAD);

  x = r*( cos( angle ) );
  y = r*( sin( angle ) );

  lon = x;
  lat = y;
}

void ImageFormat::xyToLL( int iband, double &x, double &y ) {
  if ( iband < 0 || iband >= (int)mBandSet.size() ) return;
  xyToMeter( iband, x, y );
  meterToLL( iband, x, y );
}

projPJ ImageFormat::createProj( int iband ) {
  projPJ pj = NULL;
  char   projstr[50];
  int i = 0;

  if ( iband < 0 || iband >= (int)mBandSet.size() ) return NULL;

  BandInf &binf = mBandSet[iband];

  if ( binf.proj == "utm" ) {
    char zone[50];
    sprintf( zone, "zone=%d", binf.UTMZ );

    mParms[0] = "proj=utm";
    mParms[1] = &zone[0];
    for ( i=0; i < (int)binf.parms.size(); i++ )
      mParms[i+2] = (char*)binf.parms[i].c_str();


    pj = pj_init( i+2, mParms );
  } else {
    sprintf( projstr, "proj=%s", binf.proj.c_str() );

    mParms[0] = projstr;
    for ( i=0; i < (int)binf.parms.size(); i++ )
      mParms[i+1] = (char*)binf.parms[i].c_str();

    pj = pj_init( i+1, mParms );

  }

  return pj;
}

void ImageFormat::getULCorners( ) {
  //double x, y;
  for ( int iband=0; iband < (int)mBandSet.size(); iband++ ) {
    BandInf &binf = mBandSet[iband];
    if ( binf.proj == "" )
      continue;

    //x = y = 0;
    // MUST USE NATIVE COORDINATE SYSTEM
    //getLL( iband, x, y, true );
    llToMeter( iband, binf.ulx, binf.uly );
  }
}



