#include "imagestate.h"

bool ImageState::toXML( QDomDocument &doc,
                        QDomElement &elem,
                        std::string id ) {
  QDomElement base = doc.createElement( "ImageState" );
  if ( id != "" )
    base.setAttribute( "id", (char*)id.c_str() );
  elem.appendChild( base );

  writeIntTag( doc, base, "Color", mColor );
  writeIntTag( doc, base, "Red", mRed );
  writeIntTag( doc, base, "Green", mGreen );
  writeIntTag( doc, base, "Blue", mBlue );
  writeTextTag( doc, base, "FileName", mFileName );
  writeIntTag( doc, base, "Type", mType );
  return true;
}

bool ImageState::fromXML( QDomElement &elem ) {
  if ( elem.isNull() )
    return false;

  if ( elem.hasAttribute( "id" ) )
    mID = (const char*)elem.attribute( "id" );

  if ( std::string( "ImageState" ).compare( (const char*)elem.tagName() ) )
    return false;

  mColor    = readIntTag( elem, "Color" );
  mRed      = readIntTag( elem, "Red" );
  mGreen    = readIntTag( elem, "Green" );
  mBlue     = readIntTag( elem, "Blue" );
  mFileName = readTextTag( elem, "FileName" );
  mType     = readIntTag( elem, "Type" );
  return true;
}


