#ifndef __IMAGESTATE_H
#define __IMAGESTATE_H

#include "windows_defs.h"

#include "xmlserializeable.h"

/**
 * The state of the currently loaded image.  Specifically,
 * which bands are loaded, where it's located on the file
 * system, and what type of image it is.
 */

class GV_EXPORT ImageState : public XMLSerializeable {
public:
  bool        mColor;
  int         mRed;
  int         mGreen;
  int         mBlue;
  std::string mFileName;
  int         mType;

  ImageState( ) {
    mColor = false;
    mRed   = -1;
    mGreen = -1;
    mBlue  = -1;
    mFileName = "";
    mType = -1;
  }

  virtual bool toXML( QDomDocument &doc,
                      QDomElement &elem,
                      std::string id="" );

  virtual bool fromXML( QDomElement &elem );

};

#endif



