#include "shape.h"

bool Line::nodesetToXML( QDomDocument &doc,
                         QDomElement &elem ) {
  QDomElement base = doc.createElement( "NodeSet" );
  elem.appendChild( base );

  for ( unsigned int i=0; i < mNodeSet.size(); i++ )
    mNodeSet[i].toXML( doc, base );

  return true;
}

bool Line::nodesetFromXML( QDomElement &elem ) {
  QDomNodeList nodesetlist =
  elem.elementsByTagName( "NodeSet" );
  if ( nodesetlist.count() <= 0 )
    return false;

  QDomElement base = nodesetlist.item( 0 ).toElement();

  QDomNodeList nset = base.elementsByTagName( "Node" );
  for ( unsigned int i=0; i < nset.count(); i++ ) {
    QDomElement e = nset.item( i ).toElement();
    Node node;
    node.fromXML( e );
    mNodeSet.push_back( node );
  }

  return true;
}

bool Line::fromXML( QDomElement &elem ) {
  if ( std::string( "Line" ).compare( (const char*)elem.tagName() ) )
    return false;

  nodesetFromXML( elem );
  return true;
}

bool Line::toXML( QDomDocument &doc,
                  QDomElement &elem,
                  std::string id ) {
  QDomElement base = doc.createElement( "Line" );
  if ( id != "" )
    base.setAttribute( "id", (char*)id.c_str() );
  elem.appendChild( base );

  nodesetToXML( doc, base );
  return true;
}


