#ifndef __LINEDEFDLG_H
#define __LINEDEFDLG_H

// STD LIB
#include <iostream>
#include <sstream>

// QT
#include <qdialog.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qlineedit.h>
#include <qlayout.h>
#include <qvbox.h>
#include <qhbox.h>
#include <qgrid.h>
#include <qpushbutton.h>

#include "glimsdataset.h"
#include "glimsglobals.h"

using namespace std;

/**
 * Dialog box for defining the attributes of a line.
 *
 * @todo 2006-01-23 dls - More line colors
 */
class LineDefDlg : public QDialog {
  Q_OBJECT
  protected:
  GLIMSLineData   &mLineData;
  bool            mEditing;

  QComboBox *cmbGlacType;
  QComboBox *cmbSegType;
  QComboBox *cmbSegLabel;
  QComboBox *cmbLMat;
  QComboBox *cmbRMat;
  QComboBox *cmbRFtr;
  QComboBox *cmbLFtr;
  QComboBox *cmbColor;
  QComboBox *cmbStyle;
  QComboBox *cmbWidth;

  QLineEdit *txtLXUncert;
  QLineEdit *txtLYUncert;
  QLineEdit *txtGXUncert;
  QLineEdit *txtGYUncert;

  int         miLDF;

/**
 * Fills the form's combo boxes with valid values
 */
  void  loadValids();

/**
 * Fills the form with attibutes from the selected LDF
 * when editing.
 */
  void  setSelected();

public:
/**
 * Loads the dialog with a form to allow the user to assign
 * attributes to a LDF.  If 'editing' the form will be
 * filled  with the LDF the user has selected in the
 * LineConfigDlg that opened this.
 *
 * @param linedata   New line data to add to mLinedata
 * @param ildf       New value for miLDF
 */
  LineDefDlg( GLIMSLineData &linedata, int ildf=-1 );

public slots:
/**
 * Handles the clicked() event by the OK button.  Creates
 * a new LDF and adds it to the list.  If editing, the
 * selected LDF will be assigned this new LDF.
 */
  void butOkPress( );

/**
 * Handles the clicked() event by the CANCEL button.  The
 * action taken is to close the dialog box.
 */
  void butCancelPress( );

};

#endif




