#include "linedefset.h"

LineDefSet::LineDefSet( ) {
  mLDFSet.clear();
  fromXMLFile( GLIMSGlobals::GLDF_FILE, "Global_LDF" );
}

bool LineDefSet::toXML( QDomDocument &doc,
                        QDomElement &elem,
                        std::string id ) {
  QDomElement base = doc.createElement( "LineDefSet" );
  if ( id != "" )
    base.setAttribute( "id", id.c_str() );
  elem.appendChild( base );

  for ( unsigned int ildf=0; ildf < mLDFSet.size(); ildf++ )
    mLDFSet[ildf].toXML( doc, base );
  return true;
}

bool LineDefSet::fromXML( QDomElement &elem ) {
  QDomElement e;
  QDomNode node;
  if ( std::string( "LineDefSet" ).compare( (const char*)elem.tagName() ) )
    return false;

  mLDFSet.clear();
  node = elem.firstChild();
  while ( !node.isNull() ) {
    if ( !node.isElement() )
      return false;
    e = node.toElement();
    LineDef ldf;
    ldf.fromXML( e );
    mLDFSet.push_back( ldf );
    node = node.nextSibling();
  }

  return true;
}


