#ifndef __LDFSET_H
#define __LDFSET_H

#include <qdom.h>

#include <vector>
#include <string>

#include "linedef.h"
#include "glimsglobals.h"

/**
 * This contains a set of line definitions to allow
 * easier serialization within glimsview as well as
 * a more convenient way of accessing them.
 */

class LineDefSet : public XMLSerializeable {
protected:
  std::vector<LineDef>    mLDFSet;

public:
  LineDefSet( );

  virtual bool toXML( QDomDocument &doc,
                      QDomElement &elem,
                      std::string id="" );
  virtual bool fromXML( QDomElement &elem );

  LineDef& operator[]( int ildf ) {
    return mLDFSet[ildf];
  }
  void add( LineDef &ldf ) {
    mLDFSet.push_back( ldf );
  }
  unsigned int size( ) {
    return mLDFSet.size();
  }
};

#endif



