#ifndef LINESELECTORDLG_H
#define LINESELECTORDLG_H

#include <qwidget.h>
#include <qlayout.h>
#include <qlistview.h>
#include <qpushbutton.h>
#include <qfiledialog.h>

#include "glimslinedata.h"
#include "linedefdlg.h"
#include "selectionset.h"

/**
 * Dialog for selecting a line.
 */
class LineSelectorDlg : public QWidget {
  Q_OBJECT
  protected:
  QListView       *mListView;
  GLIMSLineData       &mLineData;
  int                 mSelLDF;

public:
  LineSelectorDlg( GLIMSLineData & );
  ~LineSelectorDlg( ) {
  }

  void clear() {
    if ( mListView )
      mListView->clear();
  }

public slots:
  void makeDefaultLineDef();
  void newLineDef();
  void editLineDef();
  void changeCurLine();
  void importFile();
  void exportFile();

  void loadList();

  signals:
  void selLdfChanged( int );
  void changeSelLines( int );
  void repaintViews( );
};



#endif




