#ifndef ODLPARSER_H
#define ODLPARSER_H

#include <string>
#include <iostream>
#include <algorithm>
#include <fstream>

#include "odldefs.h"
#include "odltree.h"
#include "odlelement.h"

class ODLParser {
protected:
  ODLTree         mTop;
  std::string     mODLData;

  std::string::size_type   jpos;
  std::string::size_type   ipos;

  std::string ucase( const std::string &str );
  std::string trim( const std::string &str );
  bool parse( ODLTree &tree );

  int _uint_min( unsigned int v1, unsigned int v2 ) {
    return( v1 < v2 ) ? v1 : v2;
  }

public:
  ODLParser( const std::string &odldata );

  const ODLTree * getObject( const std::string &objname ) {
    return getObject( mTop, objname );
  }

  const ODLTree * getObject( const ODLTree& tree,
                             const std::string &objname ) const;

  const ODLTree * getGroup( const std::string &objname ) {
    return getGroup( mTop, objname );
  }

  const ODLTree * getGroup( const ODLTree& tree,
                            const std::string &grpname ) const;

  ODLTree& top( ) {
    return mTop;
  }

};

#endif




