#include "sessiondlg.h"

SessionDlg::SessionDlg( Session &ses ) :
mSession( ses ) {
  QVBoxLayout *vboxl = new QVBoxLayout( this );
  vboxl->setAutoAdd( true );

  QVBox *mainVB = new QVBox( this );
  mainVB->setMargin( 8 );
  QGrid *grid = NULL;
  QLabel *lbl = NULL;


  grid = new QGrid( 2, mainVB );

  // ADD SOURCE FIELD
  lbl = new QLabel( "RC ID: ", grid );
  mtxtRCID = new QLineEdit( grid );
  mtxtRCID->setMaxLength (3) ;


  // FIRST SECTION GRID SPACE
  grid = new QGrid( 4, mainVB );

  // ADD F/L NAME FIELDS
  lbl = new QLabel( "First Name: ", grid );
  mtxtFName = new QLineEdit( grid );

  lbl = new QLabel( " Last Name: ", grid );
  mtxtLName = new QLineEdit( grid );

  grid = new QGrid( 2, mainVB );

  // ADD SOURCE FIELD
  lbl = new QLabel( "Analysis Time: ", grid );
  mtxtAnalysisTime = new QLineEdit( grid );


  grid = new QGrid( 2, mainVB );

  // ADD SOURCE FIELD
  lbl = new QLabel( "Source: ", grid );
  mtxtDataSource = new QLineEdit( grid );

  // ADD PROCESS DESCRIPTION FIELD
  lbl = new QLabel( "Process Desc: ", grid );
//  mtxtProcDesc = new QLineEdit( grid );
  mtxtProcDesc = new QMultiLineEdit ( grid );
  mtxtProcDesc->setWordWrap (QMultiLineEdit::WidgetWidth) ;

  // ADD 3D INFO DESCRIPTION
  lbl = new QLabel( "3D Info Desc: ", grid );
//  mtxt3dDesc = new QLineEdit( grid );
  mtxt3dDesc = new QMultiLineEdit ( grid );
  mtxt3dDesc->setWordWrap (QMultiLineEdit::WidgetWidth) ;

  connect( mtxtDataSource,
           SIGNAL( textChanged( const QString & ) ),
           this,
           SLOT( dschanged( const QString & ) ) );

  connect( mtxtFName,
           SIGNAL( textChanged( const QString & ) ),
           this,
           SLOT( fnchanged( const QString & ) ) );

  connect( mtxtLName,
           SIGNAL( textChanged( const QString & ) ),
           this,
           SLOT( lnchanged( const QString & ) ) );

  /*
  connect( mtxtProcDesc,
           SIGNAL( textChanged( const QString & ) ),
           this,
           SLOT( pdchanged( const QString & ) ) );

  connect( mtxt3dDesc,
           SIGNAL( textChanged( const QString & ) ),
           this,
           SLOT( d3changed( const QString & ) ) );
  */

  connect( mtxtProcDesc,
           SIGNAL( textChanged(  ) ),
           this,
           SLOT( pdchanged( ) ) );

  connect( mtxt3dDesc,
           SIGNAL( textChanged( ) ),
           this,
           SLOT( d3changed( ) ) );


  connect( mtxtAnalysisTime,
           SIGNAL( textChanged( const QString & ) ),
           this,
           SLOT( atchanged( const QString & ) ) );

  connect( mtxtRCID,
           SIGNAL( textChanged( const QString & ) ),
           this,
           SLOT( rcchanged( const QString & ) ) );

  loadData();
}

SessionDlg::~SessionDlg( ) {

}

void SessionDlg::loadData( ) {
  mtxt3dDesc      ->setText( mSession.m3d_desc.c_str() );
  mtxtDataSource  ->setText( mSession.mDataSrc.c_str() );
  mtxtFName       ->setText( mSession.manlst_givn.c_str() );
  mtxtLName       ->setText( mSession.manlst_surn.c_str() );
  mtxtProcDesc    ->setText( mSession.mProcDesc.c_str() );
  mtxtAnalysisTime->setText( mSession.manaly_time.c_str() ) ;

  // get RC ID and convert from int to string
  stringstream rcid ;
  rcid << mSession.mRC_ID ;
  mtxtRCID      ->setText( (rcid.str()).c_str() );
}

void SessionDlg::dschanged( const QString &newtxt ) {
  mSession.mDataSrc = newtxt.latin1();
}

void SessionDlg::fnchanged( const QString &newtxt ) {
  mSession.manlst_givn = newtxt.latin1();
}

void SessionDlg::lnchanged( const QString &newtxt ) {
  mSession.manlst_surn = newtxt.latin1();
}



void SessionDlg::pdchanged( ) {
  mSession.mProcDesc = mtxtProcDesc->text() ;
}

void SessionDlg::d3changed( ) {
  mSession.m3d_desc = mtxt3dDesc->text() ;
}



void SessionDlg::pdchanged( const QString &newtxt ) {
  mSession.mProcDesc = newtxt.latin1();
}

void SessionDlg::d3changed( const QString &newtxt ) {
  mSession.m3d_desc = newtxt.latin1();
}



void SessionDlg::atchanged( const QString &newtxt ) {
  mSession.manaly_time = newtxt.latin1();
}

void SessionDlg::rcchanged( const QString &newtxt ) {
  mSession.mRC_ID = newtxt.toInt();
}


