#ifndef __SIMPLEPOINTDATA_H
#define __SIMPLEPOINTDATA_H

#include "vectordata.h"

/**
 * An extension of VectorData for the sole purpose of
 * masking out Line functions.  This remains abstract
 * and allows its child implementations to only implement
 * those functions that pertain to point data.
 */
class SimplePointData : public VectorData {
public:
  SimplePointData( ) : VectorData( POINT, NULL ) {
  }
  virtual ~SimplePointData( ) {
  }

  virtual void delLineNode( int, int ) {
  }
  virtual void delLine( int ) {
  }
  virtual void addLineNode( Node &, int, int =-1 ) {
  }
  virtual void joinLine( int, int, int, int ) {
  }
  virtual void breakLine( int, int ) {
  }
  virtual void moveLineNode( int, int, Node & ) {
  }
  virtual void addLine( Node & ) {
  }
  virtual void insertLineNode( Node &, int, int =-1 ) {
  }

  virtual bool fromXML( QDomElement &elem ) =0;
  virtual bool toXML( QDomDocument &doc,
                      QDomElement &elem,
                      std::string id="" ) =0;

  virtual void insertNode(Node &node, int inode) =0;
  virtual void delNode(int inode) =0;
  virtual void moveNode( Node &node, int inode=-1 ) =0;
  virtual void addNode( Node &node, int inode=-1 ) =0;
  virtual void push() =0;
  virtual void pushSelection( ) =0;
  virtual void pop() =0;
  virtual void redo( ) =0;
};

#endif



