#include "vectordata.h"
#include <iostream>
#include <qapplication.h>
#include <qlabel.h>

VectorData::VectorData( ShapeType type, Image *img ) :
mType( type ), mImg( img ) {

}

void VectorData::transformDataset( ) {
  QWidget *pdlg = new QWidget( NULL, NULL, true );
  QVBoxLayout *vbl = new QVBoxLayout( pdlg, 10, 10 );
  vbl->setAutoAdd( true );
  new QLabel( "Converting dataset. Please Wait.", pdlg );
  QProgressBar *pbar = new QProgressBar( pdlg );
  float pcnt = 0.0f;
  pdlg->show();
  qApp->processEvents();

  int i = 0 ;
  int szdata = size();
  for ( i=0; i < szdata; i++ ) {
    pcnt = (1.0f / (float)szdata) * (float)i;
    pbar->setProgress( (int)(pcnt * 100.0f) );
    qApp->processEvents();

    Shape &lls = *mLLSet[i];
    Shape &xys = *mXYSet[i];
    if ( mType == POINT ) {
      Node &xynode = dynamic_cast<Node&>( xys );
      Node &llnode = dynamic_cast<Node&>( lls );
      xynode = llnode;
      mImg->getXY( xynode.x, xynode.y );
    }
    else {
      Line &llline = dynamic_cast<Line&>( lls );
      Line &xyline = dynamic_cast<Line&>( xys );
      unsigned int in;
      for ( in=0; in < llline.size(); in++ ) {
        Node &llnode = llline[in];
        Node &xynode = xyline[in];
        xynode = llnode;
        mImg->getXY( xynode.x, xynode.y );
        if ( xynode.x == -999999.0 && xynode.y == -999999.0 ) {
          llline.delNode( in );
          xyline.delNode( in );
          in--;
        }
      }
    }
  }
  delete pdlg;
}




