#ifndef __VECTORLAYER_H
#define __VECTORLAYER_H

#include "vectordata.h"
#include "selectionset.h"
#include <qpainter.h>

/**
 * A part of the display that will be drawn to the
 * view according to its rank.  A vector layer is
 * able to draw itself by recieving a QPainter object
 * and drawing its VectorData member onto it.
 */
class VectorLayer {
protected:
  VectorData   *mData;
  SelectionSet &mSelSet;
  bool         mVisible;
  bool         mEditable;
  DspAttr      mLyrAttr;

public:
  VectorLayer( VectorData *data );

  virtual void draw( QPainter &p, Rect &imgclip, double scale );
  void setVisible( bool state ) {
    mVisible = state;
  }
  bool isVisible( ) {
    return mVisible;
  }
  void setEditable( bool state ) {
    mEditable = state;
  }
  bool isEditable( ) {
    return mEditable;
  }
  VectorData* getData( ) {
    return mData;
  }
};

#endif



