#include "vectorlayerset.h"
#include <iostream>

VectorLayerSet::VectorLayerSet( ) :
mActiveLayer( -1 ) {
}

VectorLayerSet::~VectorLayerSet( ) {
  for ( int ilyr=0; ilyr < (int)mLayerSet.size(); ilyr++ )
    delete mLayerSet[ilyr];
}

void VectorLayerSet::setActiveLayer( int ilyr ) {
  if ( ilyr < 0 && ilyr >= (int)mLayerSet.size() )
    return;
  mActiveLayer = ilyr;
  emit activeLayerChanged( mActiveLayer );
}

int VectorLayerSet::getActiveLayer( ) const {
  return mActiveLayer;
}

unsigned int VectorLayerSet::numLayers( ) const {
  return mLayerSet.size();
}

void VectorLayerSet::addLayer( VectorLayer *lyr ) {
  mLayerSet.push_back( lyr );
}

void VectorLayerSet::delLayer( int ) {

}

VectorLayer* VectorLayerSet::getLayer( int ilyr ) {
  if ( ilyr < 0 || ilyr >= (int)mLayerSet.size() )
    return NULL;
  return mLayerSet[ilyr];
}


