#ifndef __VECTORLAYERSET_H
#define __VECTORLAYERSET_H

#include <qobject.h>
#include <vector>

#include "vectorlayer.h"
// #include "view.h"

/**
 * A container of VectorLayer objects for managment of
 * the layers available to the user.  This could be
 * dialog based allowing the user to reorder, delete, and
 * hide layers.  Currently loading of layers in general is
 * not available.
 */
class VectorLayerSet : public QObject {
  Q_OBJECT
  protected:
  std::vector<VectorLayer*>   mLayerSet;
  int                         mActiveLayer;

public:
  VectorLayerSet( );
  ~VectorLayerSet( );

  void addLayer( VectorLayer *lyr );
  void delLayer( int );
  VectorLayer* getLayer( int ilyr );
  unsigned int numLayers( ) const;
  void setActiveLayer( int ilyr );
  int getActiveLayer( ) const;

public slots:
  void transformDatasets( ) {
    for ( int ilyr=0; ilyr < (int)mLayerSet.size(); ilyr++ )
      mLayerSet[ilyr]->getData()->transformDataset();
  }

  signals:
  void activeLayerChanged( int );
};




#endif





