#ifndef __VIEWPOPUPACTION_H
#define __VIEWPOPUPACTION_H

#include <qaction.h>

/**
 * An Extended QAction providing more information when
 * the signal "activated" is emitted.  This filters that
 * signal and re-emits an equivelant signal providing the
 * reciever a pointer to this object.
 */
class ViewPopupAction : public QAction {
  Q_OBJECT
  public:
  ViewPopupAction( const QString &text,
                   const QString &menuText,
                   int accel,
                   QObject *parent,
                   const char *name=0,
                   bool toggle=false );

public slots:
  void actSelected( ) {
    emit selected( this );
  }


  signals:
  void selected( ViewPopupAction * );

};

#endif



