#include <iostream>
#include "viewset.h"


void ViewSet::addView( View &view ) {
  if ( mMenuGroup ) {
    ViewPopupAction *action = new ViewPopupAction(
                                                 view.getViewState().mName.c_str(),
                                                 view.getViewState().mName.c_str(),
                                                 0,
                                                 mMenuGroup );
    // action->addTo( mMenuParent );
    connect( action,
             SIGNAL( selected( ViewPopupAction* ) ),
             this,
             SLOT( popupView( ViewPopupAction* ) ) );
    mMenuGroup->removeFrom( mMenuParent );
    mMenuGroup->addTo( mMenuParent );
  }

  mViewSet.push_back( &view );
  emit viewSetChanged();
}

void ViewSet::delView( int iview ) {
  if ( iview < 0 || iview >= (int)mViewSet.size() )
    return;

  delete mViewSet[iview];
  mViewSet.erase( mViewSet.begin() + iview );
  emit viewSetChanged();
}

unsigned int ViewSet::size( ) {
  return mViewSet.size();
}

View& ViewSet::getView( int iview ) {
  return *mViewSet[iview];
}

void ViewSet::redrawViews( ) {
  for ( unsigned int iview=0; iview < mViewSet.size(); iview++ ) {
    mViewSet[iview]->fullRedraw( );
  }
}

void ViewSet::repaintViews( ) {
  unsigned int iview = 0 ;
  unsigned int viewSetSize = mViewSet.size() ;
  for ( iview = 0 ; iview < viewSetSize ; iview++ ) {
    mViewSet[iview]->repaint( false );
  }
}

void ViewSet::setSelBox( Rect &selbox ) {
  for ( unsigned int iview=0; iview < mViewSet.size(); iview++ )
    mViewSet[iview]->selBoxChanged( selbox );
}

void ViewSet::resetViews( ) {
  unsigned int iview = 0;
  for ( iview=0; iview < mViewSet.size(); iview++ ) {
    mViewSet[iview]->resetView();
  }
  for ( iview=0; iview < mViewSet.size(); iview++ ) {
    mViewSet[iview]->fullRedraw();
  }
}

void ViewSet::initViews( ) {
  unsigned int iview;
  for ( iview=0; iview < mViewSet.size(); iview++ )
    mViewSet[iview]->initView();
  for ( iview=0; iview < mViewSet.size(); iview++ )
    mViewSet[iview]->fullRedraw();
}

void ViewSet::popupView( ViewPopupAction *act ) {
  std::string mtext = (const char*)act->menuText();
  for ( unsigned int iview=0; iview < mViewSet.size(); iview++ ) {
    View *v = mViewSet[iview];
    if ( v->getViewState().mName == mtext ) {
      v->show();
      v->setFocus();
    }
  }
}

void ViewSet::setRSM( ImageFormat::ScaleType st ) {
  for ( unsigned int iview=0; iview < mViewSet.size(); iview++ ) {
    mViewSet[iview]->setRSM( st );
  }
}

