#ifndef __VIEWSET_H
#define __VIEWSET_H

#include "windows_defs.h"

#include <qobject.h>

#include "view.h"
#include "extaction.h"
#include "viewpopupaction.h"

#include <vector>
#include <qaction.h>

/**
 * Contains a set of View objects and allows set wide
 * actions to be handled for all views.  This also
 * provides a current list of the views names in the
 * Window menu item.
 */

class GV_EXPORT ViewSet : public QObject {
  Q_OBJECT
  protected:
  std::vector<View*>    mViewSet ;
  QActionGroup         *mMenuGroup ;
  QWidget              *mMenuParent ;

public:
  ViewSet( ) {
    mMenuGroup = NULL;
  }
  virtual ~ViewSet( ) {
  }

  void addView( View & );
  void delView( int iview );
  unsigned int size( );
  View& getView( int iview );
  void setSelBox( Rect &selbox );
  View& operator[]( int iview ) {
    return *mViewSet[iview];
  }
  void setActGrp( QActionGroup *grp ) {
    mMenuGroup = grp;
    /*
    connect( mMenuGroup,
             SIGNAL( selected( QAction* ) ),
             this,
             SLOT( popupView( QAction* ) ) );
    */
  }
  void setMenuParent( QWidget *p ) {
    mMenuParent = p;
  }
  void setRSM( ImageFormat::ScaleType st );

public slots:
  void initViews( );
  void resetViews( );
  void repaintViews( );
  void redrawViews( );
  void popupView( ViewPopupAction* );

  signals:
  void viewSetChanged( );

};

#endif



